/*

    File: lib.h
    
    Copyright (C) 1998,1999  Wolfgang Zekoll  <wzk@quietsche-entchen.de>
    Copyright (c) 2000,2002,2003  Andreas Schoenberg  <asg@pce.de>

    This source is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 1, or (at your option)
    any later version.

    This source is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#ifndef	_LIB_INCLUDED
#define	_LIB_INCLUDED


extern char *program;
extern int verbose;


void *allocate(size_t size);
void *reallocate(void *p, size_t size);

unsigned int uppercase(unsigned int c);
int isuppercase(unsigned int c);
unsigned int lowercase(unsigned int c);
int islowercase(unsigned int c);
char *strlwr(char *string);
char *strupr(char *string);

unsigned int get_stringcode(char *string);
char *skip_ws(char *string);
char *noctrl(char *buffer);
char *get_word(char **from, char *to, int maxlen);
char *get_quoted(char **from, int c, char *to, int maxlen);
char *get_escquoted(char **from, int esc, int unesc, int c, char *to, int maxlen);
char *get_string(char **from, char *to, int maxlen);
char *get_parenthesis(char **from, int open, int close, char *string, int max);
int split(char *line, char *ptr[], int sep, int max);

int is_file(char *filename);
unsigned long get_mtime(char *filename);
int is_dir(char *dirname);
int change_dir(char *old, char *new);
char *trunc_extension(char *filename);
char *extract_name(char *name, char *filename);
char *extract_dir(char *dir, char *filename);

int strpcmp(char *string, char *pattern);
char *copy_string(char *y, char *x, int len);

#endif

